<?php

namespace Drupal\number_in_word;

/**
 * Service is number_in_word.number_in_word.
 */
class NumberInWord implements NumberInWordInterface{

  /**
   * Get a number in world.
   */
  public function number_in_word($number, $unit_type=Null, $point_type=Null) {
    if (!is_numeric($number)) {
      return 'Support only number value.';
    }
    $decimal = round($number - ($no = floor($number)), 2) * 100;
    $hundred = null;
    $digits_length = strlen($no);
    $i = 0;
    $str = [];
    // Number in word.
    $words = [
      0 => '',
      1 => 'one',
      2 => 'two',
      3 => 'three',
      4 => 'four',
      5 => 'five',
      6 => 'six',
      7 => 'seven',
      8 => 'eight',
      9 => 'nine',
      10 => 'ten',
      11 => 'eleven',
      12 => 'twelve',
      13 => 'thirteen',
      14 => 'fourteen',
      15 => 'fifteen',
      16 => 'sixteen',
      17 => 'seventeen',
      18 => 'eighteen',
      19 => 'nineteen',
      20 => 'twenty',
      30 => 'thirty',
      40 => 'forty',
      50 => 'fifty',
      60 => 'sixty',
      70 => 'seventy',
      80 => 'eighty',
      90 => 'ninety'
    ];
    // Digit in word.
    $digits = ['', 'hundred','thousand','lakh', 'crore'];
    while( $i < $digits_length ) {
      $divider = ($i == 2) ? 10 : 100;
      $number = floor($no % $divider);
      $no = floor($no / $divider);
      $i += $divider == 10 ? 1 : 2;
      if ($number) {
        $plural = (($counter = count($str)) && $number > 9) ? 's' : null;
        $hundred = ($counter == 1 && $str[0]) ? '' : null;
        $str [] = ($number < 21) ? $words[$number].' '. $digits[$counter]. $plural.' '.$hundred:$words[floor($number / 10) * 10].' '.$words[$number % 10]. ' '.$digits[$counter].$plural.' '.$hundred;
      } else $str[] = null;
    }
    $number_word = implode('', array_reverse($str));
    $point_number = ($decimal > 0) ? " " . ($words[$decimal / 10] . " " . $words[$decimal % 10]). ' '.$point_type : '';
    return ($number_word ? $number_word. $unit_type : '') . $point_number;
  }

}
